/************************************************************************
**                                                                      *
**  FILE        :  _putchar.c                                           *
**                                                                      *
**  DESCRIPTION :  Source file for putchar() routine                    *
**                                                                      *
**                 By compiling and linking this file to your absolute  *
**                 the compiler will automatically use this version of  *
**                 putchar() instead of the one that is supplied.       *

**                 In your target system a byte-wide write to address 1 *    
**                 does nothing but in the CVI196 Instruction-Set       *
**                 Simulator all byte-wide writes to address 1 are      *
**                 captured by the Log Window. This allows you to       *
**                 'Log' output as your program runs.                   *                     *
**                                                                      *
**                 For use by CVI196.                                   *                  *
**************************************************************************/


#define ChipView_sbuf_tx  (*(unsigned char *)( 0x01 )) 

int putchar(int c)
{
	ChipView_sbuf_tx = c;                                            /* Output to the transmit buffer (clears real TI bit) */
    return c;
}
